(** Confluence criteria based on critical-pair-closing systems. *)

open Term
open Substitution
open Rewriting

(*
let ground t = variables t = []

let in_nf rs t = rewrite rs t = []

let specialize rs subst l r =
  let tau = [ x, u | x, u <- subst; ground u && in_nf rs u ] in
  (substitute tau l, substitute tau r) 
*)

let specialize rs subst l r = (l, r)

let rec reaches rs ss t =
  List.mem t ss || 
  ss <> [] &&
  reaches rs (Listx.unique [ s' | s <- ss; s' <- rewrite rs s ]) t

(* R is finer than S if l ->R^* r for all l -> r in S *)
let finer1 rs (l, r) = reaches rs [l] r

let finer rs ss = List.for_all (finer1 rs) ss

let rec minimal ~geq = function
  | [] -> []
  | x :: xs -> 
      if List.for_all (fun y -> not (geq x y)) xs then
	x :: minimal ~geq xs
      else 
	minimal ~geq xs

let rec extend_term rs list t = 
  let list2 =
    [ ss'
    | ss <- list; 
      u <- subterms (nf ss t);
      l, r <- rs; 
      Some subst <- [pattern_match l u];
      ss' <- [specialize rs subst l r :: ss];
      Sn.sn "natt -v:0" ss' [] = Result.YES
    ] in
  if list2 = [] then
    list
  else 
    list @ extend_term rs list2 t

let extend_pair rs l (s, t) = 
  minimal ~geq:finer
    [ ss | ss <- extend_term rs (extend_term rs l s) t;
           Rewriting.nf ss s = Rewriting.nf ss t ]

let rec extend_pairs rs l = function
  | [] -> l
  | pair :: pairs -> extend_pairs rs (extend_pair rs l pair) pairs

let cpc rs = extend_pairs rs [[]] (Overlap.cp rs)

(*
let extend2_term 
*)
