module type OrderedType = sig 
  type t 
  val compare : t -> t -> int
end

module type S = sig
  type elt
  val index : elt -> string
end

module Make (Elt : OrderedType) = struct

  type elt = Elt.t

  module EltMap = Map.Make (Elt)

  let table = ref EltMap.empty
  
  let count = ref 0 
  
  let new_index () = incr count; "x" ^ string_of_int !count
  
  let index elt = 
    try
      EltMap.find elt !table
    with
      Not_found ->
        let idx = new_index () in
        table := EltMap.add elt idx !table;
        idx

end
