type 'a assignment =
  { int : ('a * int) list;
    num : ('a * Num.num) list;
    bool : ('a * bool) list } 

type 'a t =
  | BVar of 'a
  | Not of 'a t
  | And of 'a t list
  | Or of 'a t list
  | Implies of 'a t * 'a t
  | Eqv of 'a t * 'a t
  | Eq  of 'a e * 'a e
  | Geq of 'a e * 'a e
  | Gt  of 'a e * 'a e
and 'a e = 
  | IVar of 'a 
  | Int of int
  | Plus of 'a e list
  | Ite of 'a t * 'a e * 'a e


val debug : bool ref

val neg : 'a t -> 'a t

val conj : 'a t list -> 'a t

val disj : 'a t list -> 'a t

val ite : 'a t -> 'a e -> 'a e -> 'a e

val implies : 'a t -> 'a t -> 'a t

val geq : 'a e -> 'a e -> 'a t

val gt : 'a e -> 'a e -> 'a t

val plus : 'a e list -> 'a e

val print_c : ('a -> string) -> Format.formatter -> 'a t -> unit

val print : ('a -> string) -> Format.formatter -> 
            'a list * 'a list * 'a list * 'a t -> unit

val sat : ?tool:string -> 
          ?int:('a list) -> ?num:('a list) -> ?bool:('a list) ->
          to_string:('a -> string) -> 'a t -> 'a assignment option
