{
open Lexing
open Yices_parser

exception Lexing_error of string

}

let letter = 
  ['a'-'z' 'A'-'Z' '0'-'9' '''
   '#' '+' '-' '*' '/' '.' ',' '\\' ':' ';' '=' '<' '>' '_' '@' '`' '$'
   '{' '}' '[' ']' '|' '~' '?' '&' '"' '!' '%']

rule token = parse
  | [' ' '\r' '\t'] { token lexbuf }
  | '\n'            { new_line lexbuf; token lexbuf }
  | "("             { LPAREN }
  | ")"             { RPAREN }
  | letter+ as s    { IDENT s }
  | _ as c          { raise (Lexing_error (Format.sprintf "Lexing error: %c@." c)) }
  | eof             { EOF }
